// 0xGG Team
// Distributed under AGPL3
//
// DESCRIPTION: Vega support
// Please include the following in your index.html file
//
//    <script src="https://cdn.jsdelivr.net/npm/vega-lite@4/build/vega-lite.min.js"></script>
//    <script src="https://cdn.jsdelivr.net/npm/vega-embed@6/build/vega-embed.min.js"></script>
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};

(function (mod){ //[HyperMD] UMD patched!
  /*commonjs*/  ("object"==typeof exports&&"undefined"!=typeof module) ? mod(null, exports, require("codemirror"), require("../addon/fold-code"), require("../addon/fold"), require("yamljs")) :
  /*amd*/       ("function"==typeof define&&define.amd) ? define(["require","exports","codemirror","../addon/fold-code","../addon/fold","yamljs"], mod) :
  /*plain env*/ mod(null, (this.HyperMD.FoldCodeWithVegaLite = this.HyperMD.FoldCodeWithVegaLite || {}), CodeMirror, HyperMD.FoldCode, HyperMD.Fold, YAML);
})(function (require, exports, CodeMirror, fold_code_1, fold_1, YAML) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    CodeMirror = __importStar(CodeMirror);
    YAML = __importStar(YAML);
    exports.VegaLiteRenderer = function (code, info) {
        var id = "_vega-lite_id_" + Math.round(1e9 * Math.random()).toString(36);
        var el = document.createElement("div");
        el.id = id;
        var asyncRenderer = null;
        try {
            var spec = {};
            if (code.trim()[0] !== "{") {
                spec = YAML.parse(code);
            }
            else {
                spec = JSON.parse(code);
            }
            vegaEmbed("#" + id, spec);
        }
        catch (error) {
            el.innerText = error.toString();
        }
        return {
            element: el,
            asyncRenderer: null
        };
    };
    if (typeof vegaEmbed !== "undefined") {
        CodeMirror.defineOption("vega-lite", null, function (cm) {
            fold_code_1.getAddon(cm).clear("vega-lite");
            fold_1.getAddon(cm).startFold();
        });
        fold_code_1.registerRenderer({
            name: "vega-lite",
            pattern: /^vega\-lite$/i,
            renderer: exports.VegaLiteRenderer,
            suggested: true
        });
        if (window["VICKYMD_DEBUG"]) {
            console.log("[HyperMD] PowerPack fold-code-with-vega-lite loaded.");
        }
    }
    else {
        if (window["VICKYMD_DEBUG"]) {
            console.log("[HyperMD] PowerPack fold-code-with-vega-lite failed to load.\nPlease include  \n\n    <script src=\"https://cdn.jsdelivr.net/npm/vega-lite@4/build/vega-lite.min.js\"></script>\n    <script src=\"https://cdn.jsdelivr.net/npm/vega-embed@6/build/vega-embed.min.js\"></script>\n\nin your HTML file");
        }
    }
});
