
(function (mod){ //[HyperMD] UMD patched!
  /*commonjs*/  ("object"==typeof exports&&"undefined"!=typeof module) ? mod(null, exports, ) :
  /*amd*/       ("function"==typeof define&&define.amd) ? define(["require","exports"], mod) :
  /*plain env*/ mod(null, (this.HyperMD.PreviewFeatureWidget = this.HyperMD.PreviewFeatureWidget || {}), );
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.default = (function (md) {
        var oldCodeInlineRenderer = md.renderer.rules.code_inline;
        md.renderer.rules.code_inline = function (tokens, idx, options, env, slf) {
            var content = tokens[idx].content.trim() || "";
            if (content.startsWith("@")) {
                // TODO: Refactor fold-widget.ts
                var widgetName = void 0;
                var widgetAttributes = {};
                var firstSpaceMatch = content.match(/\s/);
                var firstSpace = firstSpaceMatch ? firstSpaceMatch.index : -1;
                if (firstSpace > 0) {
                    widgetName = content
                        .slice(0, firstSpace)
                        .trim()
                        .replace(/^@/, "");
                    try {
                        widgetAttributes = JSON.parse("{" +
                            content
                                .slice(firstSpace + 1)
                                .trim()
                                .replace(/\\`/g, "`") +
                            "}");
                    }
                    catch (error) {
                        widgetName = "error";
                        widgetAttributes = { message: error.toString() };
                    }
                }
                else {
                    widgetName = content.trim().replace(/^@/, "");
                }
                if (widgetName) {
                    return "<span class=\"vickymd-widget\" data-widget-name='" + widgetName + "' data-widget-attributes='" + JSON.stringify(widgetAttributes) + "'></span>";
                }
            }
            return oldCodeInlineRenderer(tokens, idx, options, env, slf);
        };
    });
});
